SystemOrganization addCategory: #LoadOrderTests!

!WriteStream methodsFor: '*loadordertests' stamp: 'jgf 2/6/2009 12:01'!
show: aString

	^self nextPutAll: aString.
	! !

Object subclass: #SeasideLoadOrderTests
	instanceVariableNames: 'userName password seaside29 komHttpServer baseTests baseUndeclared doTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoadOrderTests'!

!SeasideLoadOrderTests commentStamp: 'jgf 2/6/2009 12:08' prior: 0!
SeasideLoadOrderTests provides a single class that loads the packages described on the LoadOrder Wiki (http://code.google.com/p/seaside/wiki/LoadOrder), and shows the errors and undefined along the way.!

!SeasideLoadOrderTests class methodsFor: 'initialization' stamp: 'jgf 2/6/2009 11:20'!
initialize

	(UIManager default confirm: 'Load Seaside 2.9?') ifTrue: [
		self new doLoad.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 17:03'!
adminToolsPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-Tools-OmniBrowser-lr.6.mcz';
		add: seaside29 -> 'Seaside-Pharo-Tools-OmniBrowser-jf.2.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 17:14'!
basicPackages

	^OrderedCollection new
		"Platform"
		add: (Array 
			with: seaside29 -> 'Seaside-Platform-pmm.78.mcz'
			with: seaside29 -> 'Seaside-Pharo-Platform-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Platform-pmm.86.mcz'
			with: seaside29 -> 'Seaside-Tests-Pharo-Platform-jf.2.mcz');
		"Core"
		add: (Array 
			with: seaside29 -> 'Seaside-Core-pmm.539.mcz'
			with: seaside29 -> 'Seaside-Tests-Core-jf.148.mcz'
			with: seaside29 -> 'Seaside-Tests-UTF8-lr.3.mcz'
			with: seaside29 -> 'Seaside-Pharo-Core-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Pharo-Core-jf.2.mcz');
		"Canvas"
		add: (Array 
			with: seaside29 -> 'Seaside-Canvas-pmm.64.mcz'
			with: seaside29 -> 'Seaside-Tests-Canvas-pmm.28.mcz');
		"Session"
		add: (Array 
			with: seaside29 -> 'Seaside-Session-pmm.114.mcz'
			with: seaside29 -> 'Seaside-Tests-Session-pmm.26.mcz');
		"Component"
		add: (Array 
			with: seaside29 -> 'Seaside-Component-jf.69.mcz'
			with: seaside29 -> 'Seaside-Tests-Component-lr.22.mcz');
		"RenderLoop"
		add: (Array 
			with: seaside29 -> 'Seaside-RenderLoop-pmm.64.mcz'
			with: seaside29 -> 'Seaside-Tests-RenderLoop-lr.8.mcz');
		"Tools"
		add: (Array
			with: seaside29 -> 'Seaside-Tools-Core-jf.8.mcz');
		"??"
		add: (Array
			with: seaside29 -> 'Seaside-SwineFoo-jf.1.mcz');
		"Environment"
		add: (Array 
			with: seaside29 -> 'Seaside-Environment-jf.55.mcz'
			with: seaside29 -> 'Seaside-Pharo-Environment-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Environment-jf.15.mcz');
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 16:01'!
comanchePackages

	^OrderedCollection new
		add: komHttpServer	-> 'DynamicBindings-damiencassou.9.mcz';
		add: komHttpServer	-> 'KomServices-gc.19.mcz';
		add: komHttpServer	-> 'KomHttpServer-damiencassou.47.mcz';
			
		add: seaside29		-> 'Seaside-Adaptors-Comanche-lr.47.mcz';
		add: seaside29		-> 'Seaside-Tests-Adaptors-Comanche-lr.10.mcz';
		yourself.
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'lr 8/30/2009 19:08'!
cometPackages

	^OrderedCollection new
		add: seaside29 -> 'Comet-Core-lr.38.mcz';
		add: seaside29 -> 'Comet-Pharo-Core-lr.1.mcz';
		add: seaside29 -> 'Comet-Tests-Core-jf.6.mcz';
		add: seaside29 -> 'Comet-Examples-lr.13.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'utility' stamp: 'jgf 2/6/2009 09:08'!
condenceChanges
"
	SeasideLoadOrderTests new condenseChanges.
"
	Smalltalk condenseChanges.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
doLoad

	self groups do: [:aList | 
		self 
			loadPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
doTests

	| suite result |
	doTests ifFalse: [^self].
	suite := TestCase suite.
	baseTests do: [:oldTest | 
		| duplicate |
		duplicate := suite tests detect: [:newTest | newTest class == oldTest class and: [newTest selector == oldTest selector]].
		suite tests remove: duplicate.
	].
	result := suite run.
	Transcript cr; tab; show: result printString.
	result defects do: [:each | 
		Transcript cr; tab; tab; show: each printString.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 17:01'!
emailPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-Email-lr.10.mcz';
		add: seaside29 -> 'Seaside-Tests-Email-pmm.5.mcz';
		add: seaside29 -> 'Seaside-Pharo-Email-jf.2.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 17:23'!
groups

	^OrderedCollection new
		addAll: self basicPackages;
		addAll: self traditionalPackages;
		add: self adminToolsPackages;
		add: self rssPackages;
		add: self javascriptPackages;
		add: self jQueryPackages;
		add: self prototypePackages;
		add: self scriptaculousPackages;
		add: self htmlPackages;
		add: self internetExplorerPackages;
		add: self emailPackages;
		add: self comanchePackages;
		add: self cometPackages;
		yourself.
		! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 7/16/2009 14:32'!
htmlPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-HTML5-pmm.6.mcz';
		add: seaside29 -> 'Seaside-Tests-HTML5-lr.12.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'initialize-release' stamp: 'jgf 2/6/2009 16:12'!
initialize

	super initialize.
	userName := UIManager default
		request: 'SqueakSource User Name (empty is fine)?'
		initialAnswer: ''.
	password := UIManager default
		request: 'SqueakSource Password (empty is fine)?'
		initialAnswer: ''.
	seaside29 := self seaside29.
	komHttpServer := self komHttpServer.
	doTests := UIManager default confirm: 'Run tests as packages are loaded?'.
	doTests ifTrue: [
		baseTests := TestCase suite tests.
		baseUndeclared := Undeclared keys.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 6/15/2009 11:53'!
internetExplorerPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-InternetExplorer-lr.4.mcz';
		add: seaside29 -> 'Seaside-Tests-InternetExplorer-mls.7.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 8/30/2009 11:24'!
jQueryPackages

	^OrderedCollection new
		add: seaside29 -> 'JQuery-Core-lr.78.mcz';
		add: seaside29 -> 'JQuery-Tests-Core-lr.85.mcz';
		add: seaside29 -> 'JQuery-UI-jf.37.mcz';
		add: seaside29 -> 'JQuery-Tests-UI-lr.52.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 8/30/2009 20:10'!
javascriptPackages

	^OrderedCollection new
		add: seaside29 -> 'Javascript-Core-pmm.59.mcz';
		add: seaside29 -> 'Javascript-Pharo-Core-lr.1.mcz';
		add: seaside29 -> 'Javascript-Tests-Core-pmm.42.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:15'!
komHttpServer

	^MCHttpRepository
		location: 'http://www.squeaksource.com/KomHttpServer'
		user: userName
		password: password.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
loadPackage: aString from: aRepository

	| version repositoryGroup transcript stream |
	version := aRepository loadVersionFromFileNamed: aString.
	transcript := Transcript.
	stream := WriteStream on: String new.
	[
		Transcript := stream.
		version load.
	] ensure: [
		Transcript := transcript.
	].
	self reportToTranscript: stream contents.
	repositoryGroup := version workingCopy repositoryGroup.
	repositoryGroup addRepository: aRepository.
	Transcript cr; show: 'Loaded ' , aString.
	self showUndeclared.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:23'!
loadPackages: aList

	Transcript cr.
	aList do: [:assoc |
		self
			loadPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 7/20/2009 08:03'!
prototypePackages

	^OrderedCollection new
		add: seaside29 -> 'Prototype-Core-jf.6.mcz';
		add: seaside29 -> 'Prototype-Tests-Core-jf.4.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:39'!
reportToTranscript: aString

	| list |
	list := aString subStrings: (Array with: $().
	list := list collect: [:each | each withBlanksTrimmed].
	list := list reject: [:each | each isEmpty].
	list := list reject: [:each | 
		16 < each size and: [ (each copyFrom: each size - 14 to: each size) = ' is Undeclared)'].
	].
	list isEmpty ifTrue: [^self].
	Transcript nextPutAll: aString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 15:59'!
rssPackages

	^OrderedCollection new
		add: seaside29 -> 'RSS-Core-jf.51.mcz';
		add: seaside29 -> 'RSS-Tests-Core-jf.19.mcz';
		add: seaside29 -> 'RSS-Examples-jf.17.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 7/20/2009 08:03'!
scriptaculousPackages

	^OrderedCollection new
		add: seaside29 -> 'Scriptaculous-Core-jf.88.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Core-jf.32.mcz';
		add: seaside29 -> 'Scriptaculous-Components-lr.83.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Components-lr.22.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:09'!
seaside29

	^MCHttpRepository
		location: 'http://www.squeaksource.com/Seaside29'
		user: ''
		password: ''.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
showUndeclared

	| newUndeclared |
	doTests ifFalse: [^self].
	newUndeclared := Undeclared keys.
	baseUndeclared do: [:each | newUndeclared remove: each].
	newUndeclared isEmpty ifTrue: [^self].
	Transcript cr; tab; show: 'Undeclared: ' , newUndeclared asSortedCollection asArray printString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/1/2009 17:09'!
traditionalPackages

	^OrderedCollection new
		"Functional Tests"	
		add: (Array 
			with: seaside29 -> 'Seaside-Tests-Functional-pmm.86.mcz'
			with: seaside29 -> 'Seaside-Tests-Pharo-Functional-jf.2.mcz');
		"Continuations"
		add: (Array 
			with: seaside29 -> 'Seaside-Pharo-Continuation-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Pharo-Continuation-jf.2.mcz');
		"Flow"
		add: (Array 
			with: seaside29 -> 'Seaside-Flow-lr.15.mcz'
			with: seaside29 -> 'Seaside-Pharo-Flow-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Flow-lr.17.mcz');
		"WebTools"
		add: (Array 
			with: seaside29 -> 'Seaside-Tools-Web-pmm.10.mcz'
			with: seaside29 -> 'Seaside-Pharo-Tools-Web-jf.2.mcz'
			with: seaside29 -> 'Seaside-Tests-Tools-Web-pmm.4.mcz');
		"Development"
		add: (Array 
			with: seaside29 -> 'Seaside-Development-lr.110.mcz'
			with: seaside29 -> 'Seaside-Pharo-Development-jf.3.mcz'
			with: seaside29 -> 'Seaside-Tests-Development-jf.31.mcz'
			with: seaside29 -> 'Seaside-Tests-Pharo-Development-jf.2.mcz');
		"Examples"
		add: (Array 
			with: seaside29 -> 'Seaside-Examples-jf.13.mcz'
			with: seaside29 -> 'Seaside-Tests-Examples-jok.3.mcz');
			yourself.! !
SeasideLoadOrderTests initialize!
